'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var reactDraggable = require('react-draggable');
var debounce = _interopDefault(require('lodash.debounce'));
var $ = _interopDefault(require('cash-dom'));

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ResizeContainer {\r\n    \r\n}\r\n\r\n.ResizeContent {\r\n    flex-grow: 1;\r\n    align-self: stretch;\r\n    display: flex;\r\n}\r\n.ResizeContentVertical {\r\n    flex-flow: column;\r\n}\r\n.ResizeContentHorizontal {\r\n    flex-flow: row;\r\n}\r\n.ResizeHandleHorizontal {\r\n    cursor: ew-resize;\r\n    width: 12px;\r\n    height: 50px;\r\n    background: white;\r\n    border: 2px solid lightgray;\r\n    border-radius: 8px;\r\n    text-align: center;\r\n    z-index: 99999;\r\n    overflow: hidden;\r\n    display: flex;\r\n    align-items: center ;\r\n\r\n}\r\n\r\n.ResizeHandleVertical {\r\n    cursor: ns-resize;\r\n    width:50px;\r\n    height: 12px;\r\n    border-radius: 8px;\r\n    background: white;\r\n    border: 2px solid lightgray;\r\n    z-index: 99999;\r\n    overflow: hidden;\r\n    display: flex;\r\n    justify-content: center;\r\n\r\n}\r\n\r\n.ResizeHandlePositionW {\r\n    margin-left:-8px;\r\n    margin-right: -9px;\r\n}\r\n.ResizeHandlePositionE {\r\n    margin-right:-8px;\r\n    margin-left: -9px;\r\n}\r\n.ResizeHandlePositionS {\r\n    margin-top: -9px;\r\n    margin-bottom: -8px;\r\n}\r\n.ResizeHandlePositionN {    \r\n    margin-top: -8px;   \r\n    margin-bottom: -9px;\r\n}\r\n\r\n.ResizeHandleHorizontal>span, .ResizeHandleVertical>span {\r\n    display: inline-block;\r\n    overflow: hidden;\r\n    font-size: 12px;\r\n    font-weight: bold;\r\n    font-family: sans-serif;\r\n    letter-spacing: 1px;\r\n    color: #b3b3b3;\r\n    text-shadow: 1px 0 1px rgb(90, 90, 90);\r\n}\r\n.ResizeHandleHorizontal>span {\r\n    line-height: 4px;\r\n}\r\n.ResizeHandleVertical>span {\r\n    text-align: center;\r\n    line-height: 12px;\r\n    margin-top: -3px;\r\n}\r\n.ResizeHandleHorizontal>span::after{\r\n    content: '. . . . . . . .';\r\n}\r\n.ResizeHandleVertical>span::after{\r\n    content: '......';\r\n}";
styleInject(css);

var ContainerStyleHorizontal = {
  display: 'flex',
  alignItems: 'center',
  flexFlow: 'row nowrap'
};
var ContainerStyleVertical = {
  display: 'flex',
  alignItems: 'center',
  flexFlow: 'column nowrap'
};
var HandleDirectionStyles = {
  w: "ResizeHandlePositionW",
  e: "ResizeHandlePositionE",
  n: "ResizeHandlePositionN",
  s: "ResizeHandlePositionS"
};

var ResizePanel =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ResizePanel, _React$Component);

  function ResizePanel(props) {
    var _this;

    _classCallCheck(this, ResizePanel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ResizePanel).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isHorizontal", function () {
      return _this.props.direction === "w" || _this.props.direction === "e";
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleDrag", function (e, ui) {
      var direction = _this.props.direction;
      var factor = direction === "e" || direction === "s" ? -1 : 1;
      var content = _this.refs.content;
      var minWidth = (_this.isHorizontal() ? content.children[0].scrollWidth : content.children[0].scrollheight) || 0;
      var delta = _this.isHorizontal() ? ui.deltaX : ui.deltaY;

      _this.setState(function (s, p) {
        return {
          size: Math.max(10, s.size - delta * factor)
        };
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleDragEnd", function (e, ui) {
      _this.validateSize();
    });

    _this.state = {
      size: 0
    };
    _this.validateSize = debounce(_this.validateSize, 100).bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(ResizePanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$refs = this.refs,
          content = _this$refs.content,
          wrapper = _this$refs.wrapper;
      var actualContent = content.children[0];
      this.setState({
        size: this.isHorizontal() ? $(actualContent).outerWidth(true) : $(actualContent).outerHeight(true)
      });
    }
  }, {
    key: "validateSize",
    value: function validateSize() {
      var isHorizontal = this.isHorizontal();
      var _this$refs2 = this.refs,
          content = _this$refs2.content,
          wrapper = _this$refs2.wrapper;
      var actualContent = content.children[0];
      var containerParent = wrapper.parentElement; // If our resizing has left the parent container's content overflowing
      // then we need to shrink back down to fit

      var overflow = isHorizontal ? containerParent.scrollWidth - containerParent.clientWidth : containerParent.scrollHeight - containerParent.clientHeight;

      if (overflow) {
        this.setState(_objectSpread({}, this.state, {
          size: isHorizontal ? actualContent.scrollWidth - overflow : actualContent.scrollHeight - overflow
        }));
      } // 
      // Or if our size doesn't equal the actual content size, then we
      // must have pushed past the min size of the content, so resize back


      var minSize = isHorizontal ? $(actualContent).outerWidth(true) : $(actualContent).outerHeight(true);

      if (this.state.size !== minSize) {
        this.setState(_objectSpread({}, this.state, {
          size: minSize
        }));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var dragHandlers = {
        onDrag: this.handleDrag,
        onStop: this.handleDragEnd
      };
      var direction = this.props.direction;
      var isHorizontal = this.isHorizontal();
      var containerStyle = isHorizontal ? ContainerStyleHorizontal : ContainerStyleVertical;
      var handleClasses = "ResizeHandle " + HandleDirectionStyles[direction];
      handleClasses += isHorizontal ? " ResizeHandleHorizontal " : " ResizeHandleVertical ";
      var contentStyle = isHorizontal ? {
        width: this.state.size + 'px'
      } : {
        height: this.state.size + 'px'
      };
      var contentClassName = "ResizeContent " + (isHorizontal ? "ResizeContentHorizontal" : "ResizeContentVertical");
      var content = [React.createElement("div", {
        key: "content",
        ref: "content",
        className: contentClassName,
        style: contentStyle
      }, React.Children.only(this.props.children))];
      var handle = React.createElement(reactDraggable.DraggableCore, _extends({
        key: "handle"
      }, dragHandlers), React.createElement("div", {
        className: handleClasses
      }, React.createElement("span", null)));

      if (direction === 'w' || direction === 'n') {
        content.unshift(handle);
      } else {
        content.push(handle);
      }

      return React.createElement("div", {
        ref: "wrapper",
        style: containerStyle,
        className: "ResizeContainer"
      }, content);
    }
  }]);

  return ResizePanel;
}(React.Component);

module.exports = ResizePanel;
